package com.nextbiometrics.devices.jna;

import com.nextbiometrics.devices.NBUCommInterface;
import com.sun.jna.Structure;
import java.util.Arrays;
import java.util.List;

public class NBUCommInterfaceStruct extends Structure {
    /* 53 */ public int interfaceVersion = 1;
    /* 54 */ public NBUCommInterface.InitializeHandler initializeHandler = null;
    /* 55 */ public NBUCommInterface.TerminateHandler terminateHandler = null;
    /* 56 */ public NBUCommInterface.OpenHandler openHandler = null;
    /* 57 */ public NBUCommInterface.CloseHandler closeHandler = null;
    /* 58 */ public NBUCommInterface.ReopenHandler reopenHandler = null;
    /* 59 */ public NBUCommInterface.SetTimeoutHandler setTimeoutHandler = null;
    /* 60 */ public NBUCommInterface.WaitForPacketStartHandler waitForPacketStartHandler = null;
    /* 61 */ public NBUCommInterface.ReceiveByteHandler receiveByteHandler = null;
    /* 62 */ public NBUCommInterface.SetRemainingSizeHandler setRemainingSizeHandler = null;
    /* 63 */ public NBUCommInterface.StartPacketSendHandler startPacketSendHandler = null;
    /* 64 */ public NBUCommInterface.SendByteHandler sendByteHandler = null;
    /* 65 */ public NBUCommInterface.GetPropertyHandler getPropertyHandler = null;
    /* 66 */ public NBUCommInterface.SetPropertyHandler setPropertyHandler = null;
    /* 67 */ public NBUCommInterface.ResetHandler resetHandler = null;
    /* 68 */ public NBUCommInterface.EnumDevicesInitHandler enumDevicesInitHandler = null;
    /* 69 */ public NBUCommInterface.EnumDevicesDoneHandler enumDevicesDoneHandler = null;
    /* 70 */ public NBUCommInterface.EnumGetDevNumberHandler enumGetDevNumberHandler = null;
    /* 71 */ public NBUCommInterface.EnumGetDevInfoHandler enumGetDevInfoHandler = null;

    protected List<String> getFieldOrder() {
        /* 14 */ return Arrays.asList(new String[] { "interfaceVersion", "initializeHandler", "terminateHandler",
                "openHandler", "closeHandler", "reopenHandler", "setTimeoutHandler", "waitForPacketStartHandler",
                "receiveByteHandler", "setRemainingSizeHandler", "startPacketSendHandler", "sendByteHandler",
                "getPropertyHandler", "setPropertyHandler", "resetHandler", "enumDevicesInitHandler",
                "enumDevicesDoneHandler", "enumGetDevNumberHandler", "enumGetDevInfoHandler" });
    }

    public NBUCommInterfaceStruct() {
    }

    public NBUCommInterfaceStruct(NBUCommInterface.InitializeHandler initializeHandler,
            NBUCommInterface.TerminateHandler terminateHandler, NBUCommInterface.OpenHandler openHandler,
            NBUCommInterface.CloseHandler closeHandler, NBUCommInterface.ReopenHandler reopenHandler,
            NBUCommInterface.SetTimeoutHandler setTimeoutHandler,
            NBUCommInterface.WaitForPacketStartHandler waitForPacketStartHandler,
            NBUCommInterface.ReceiveByteHandler receiveByteHandler,
            NBUCommInterface.SetRemainingSizeHandler setRemainingSizeHandler,
            NBUCommInterface.StartPacketSendHandler startPacketSendHandler,
            NBUCommInterface.SendByteHandler sendByteHandler, NBUCommInterface.GetPropertyHandler getPropertyHandler,
            NBUCommInterface.SetPropertyHandler setPropertyHandler, NBUCommInterface.ResetHandler resetHandler,
            NBUCommInterface.EnumDevicesInitHandler enumDevicesInitHandler,
            NBUCommInterface.EnumDevicesDoneHandler enumDevicesDoneHandler,
            NBUCommInterface.EnumGetDevNumberHandler enumGetDevNumberHandler,
            NBUCommInterface.EnumGetDevInfoHandler enumGetDevInfoHandler) {
        /* 101 */ this.initializeHandler = initializeHandler;
        /* 102 */ this.terminateHandler = terminateHandler;
        /* 103 */ this.openHandler = openHandler;
        /* 104 */ this.closeHandler = closeHandler;
        /* 105 */ this.reopenHandler = reopenHandler;
        /* 106 */ this.setTimeoutHandler = setTimeoutHandler;
        /* 107 */ this.waitForPacketStartHandler = waitForPacketStartHandler;
        /* 108 */ this.receiveByteHandler = receiveByteHandler;
        /* 109 */ this.setRemainingSizeHandler = setRemainingSizeHandler;
        /* 110 */ this.startPacketSendHandler = startPacketSendHandler;
        /* 111 */ this.sendByteHandler = sendByteHandler;
        /* 112 */ this.getPropertyHandler = getPropertyHandler;
        /* 113 */ this.setPropertyHandler = setPropertyHandler;
        /* 114 */ this.resetHandler = resetHandler;
        /* 115 */ this.enumDevicesInitHandler = enumDevicesInitHandler;
        /* 116 */ this.enumDevicesDoneHandler = enumDevicesDoneHandler;
        /* 117 */ this.enumGetDevNumberHandler = enumGetDevNumberHandler;
        /* 118 */ this.enumGetDevInfoHandler = enumGetDevInfoHandler;
    }

    public static class ByValue extends NBUCommInterfaceStruct implements Structure.ByValue {
        public ByValue() {
            /* 23 */ this(null);
        }

        public ByValue(NBUCommInterfaceStruct value) {
            /* 28 */ if (value != null) {
                /* 29 */ this.interfaceVersion = value.interfaceVersion;
                /* 30 */ this.initializeHandler = value.initializeHandler;
                /* 31 */ this.terminateHandler = value.terminateHandler;
                /* 32 */ this.openHandler = value.openHandler;
                /* 33 */ this.closeHandler = value.closeHandler;
                /* 34 */ this.reopenHandler = value.reopenHandler;
                /* 35 */ this.setTimeoutHandler = value.setTimeoutHandler;
                /* 36 */ this.waitForPacketStartHandler = value.waitForPacketStartHandler;
                /* 37 */ this.receiveByteHandler = value.receiveByteHandler;
                /* 38 */ this.setRemainingSizeHandler = value.setRemainingSizeHandler;
                /* 39 */ this.startPacketSendHandler = value.startPacketSendHandler;
                /* 40 */ this.sendByteHandler = value.sendByteHandler;
                /* 41 */ this.getPropertyHandler = value.getPropertyHandler;
                /* 42 */ this.setPropertyHandler = value.setPropertyHandler;
                /* 43 */ this.resetHandler = value.resetHandler;
                /* 44 */ this.enumDevicesInitHandler = value.enumDevicesInitHandler;
                /* 45 */ this.enumDevicesDoneHandler = value.enumDevicesDoneHandler;
                /* 46 */ this.enumGetDevNumberHandler = value.enumGetDevNumberHandler;
                /* 47 */ this.enumGetDevInfoHandler = value.enumGetDevInfoHandler;
            }
        }
    }
}
